import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;
import java.awt.Robot;
import java.awt.MouseInfo;
import java.awt.PointerInfo;
import greenfoot.core.*;
import javax.swing.*;
import java.awt.*;
/**
 * Write a description of class Camera here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Camera extends Actor
{
    public float Xp = 120;
    public float Yp = 120;
    public float r = 0;
    public float FOV = 80;
    public int res = 600;
    public double mouseSensitivity = -0.05;
    public float viewDist = 1000;
    public float AntiFishEye = -0.02f;
    public int prevXmouse;
    private Vector2 c = new Vector2(10000,10000);
    private Vector2 p = new Vector2(10000,10000);
    private Robot rob;
    private Vector2 centerLock = new Vector2(600,500);
    public float BuffDist = 10f; 
    public Camera()
    {
        JPanel panel = WorldHandler.getInstance().getWorldCanvas();
        GreenfootImage image = new GreenfootImage(1, 1);
        Cursor cursor = Toolkit.getDefaultToolkit().createCustomCursor(image.getAwtImage(), new Point(0, 0), "");
        panel.setCursor(cursor);
        try {   
            rob = new Robot();
        } catch (Exception e) {
        }
        //MouseInfo mouse = Greenfoot.getMouseInfo();
        //if(mouse != null){
        PointerInfo pi = MouseInfo.getPointerInfo();
        prevXmouse = pi.getLocation().x;
    }
    
    public void MoveWithPhysics(float x, float y)
    {
        Game world = (Game) getWorld();
        for (Wall ii : world.WallList())
        {
            PhysicsRay(new Vector2(ii.x1,ii.y1), new Vector2(ii.x2,ii.y2), new Vector2(Xp,Yp), new Vector2(Xp + x, Yp + y));
            
        }
        if(p.x != 10000 && p.y != 10000)
        {
            // shorten p vector
            p.x -= BuffDist * (Math.cos(Math.atan2(p.y - Yp , p.x - Xp) * 180 / Math.PI));
            p.y -= BuffDist * (Math.sin(Math.atan2(p.y - Yp , p.x - Xp) * 180 / Math.PI));
            System.out.println("X: " + p.x + "  Y: " + p.y);
            Xp = p.x; Yp = p.y;
        }else{
            Xp += x;
            Yp += y;
        }
        p = new Vector2(10000,10000);
    }
    
    /**
     * Act - do whatever the Camera wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        setImage(new GreenfootImage(1,1));
        PointerInfo pi = MouseInfo.getPointerInfo();
        
        if(Greenfoot.isKeyDown("escape")){Greenfoot.stop();}
        
        if(Greenfoot.isKeyDown("F1")){centerLock.x = pi.getLocation().x;centerLock.y = pi.getLocation().y;}
        r += (prevXmouse - pi.getLocation().x)*mouseSensitivity;
        prevXmouse = (int) centerLock.x;
        if(centerLock != null)
        {
            rob.mouseMove((int)centerLock.x,(int) centerLock.y);
        }
        
        if(Greenfoot.isKeyDown("w"))
        {
            MoveWithPhysics((float)Math.cos(Math.toRadians(r)),(float) Math.sin(Math.toRadians(r)));
        }
        if(Greenfoot.isKeyDown("a"))
        {
            MoveWithPhysics((float)-Math.cos(Math.toRadians(r+90)),(float) -Math.sin(Math.toRadians(r+90)));
        }
        if(Greenfoot.isKeyDown("s"))
        {
            MoveWithPhysics((float)-Math.cos(Math.toRadians(r)),(float) -Math.sin(Math.toRadians(r)));
        }
        if(Greenfoot.isKeyDown("d"))
        {
            MoveWithPhysics((float)Math.cos(Math.toRadians(r+90)),(float) Math.sin(Math.toRadians(r+90)));
        }
        
        Game world = (Game) getWorld();
        world.getBackground().setColor(Color.WHITE);
        world.getBackground().fill();
        world.getBackground().setColor(Color.BLACK);
        c = new Vector2(10000,10000);
        for(int i = 0; i<res; i++)
        {
            //knowns: the lines for walls
            //        the angle to shoot the ray
            //        the origin of the ray
            float rayOriginX = Xp - (float)(Math.cos(Math.toRadians(r+90))*(i-res/2)*AntiFishEye);
            float rayOriginY = Yp - (float)(Math.sin(Math.toRadians(r+90))*(i-res/2)*AntiFishEye);
            float RayAngle = (float) Math.toRadians(r + i*(FOV/res) - FOV/2);
            float xRayEnd=rayOriginX+(float)(Math.cos(RayAngle)*viewDist);
            float yRayEnd=rayOriginY+(float)(Math.sin(RayAngle)*viewDist);
            //int ii = 0;
            //searchForColl:
            //while(
            //raycast(
            //(world.WallList()[ii]).x1,(world.WallList()[ii]).y1,
            //(world.WallList()[ii]).x2,(world.WallList()[ii]).y2,
            //Xp,Yp,xRayEnd,yRayEnd
            //)!=1)
            //{
            //    if((ii>=(world.numWalls-1))){c.x = Xp; c.y = Yp; break searchForColl;}
            //    ii++;
            //}
            for (Wall ii : world.WallList())
            {
                raycast(ii.x1,ii.y1,ii.x2,ii.y2,rayOriginX,rayOriginY,xRayEnd,yRayEnd);
            }
            if((c.x != 10000)&&(c.y != 10000)){
                //Draw a line based on length
                if(dist(rayOriginX, rayOriginY, c.x, c.y) != 0){
                int lineLength = (int) (10000/dist(rayOriginX, rayOriginY, c.x, c.y));
                world.getBackground().fillRect(
                ((world.getWidth()-world.getHeight()>0)?((world.getWidth()-world.getHeight())/2):(0))+i*(world.getWidth()/res),
                ((world.getHeight()/2) - (lineLength/2)),
                (world.getWidth()/res),
                lineLength
                );}
                //i*(world.getWidth()/res),
                //(int)((world.getHeight()/2) - (lineLength/2)),
                //i*(world.getWidth()/res),
                //(int)((world.getHeight()/2) + (lineLength/2)));
            }
            c = new Vector2(10000,10000);
        }
        if(world.getWidth()-world.getHeight()>0)
        {
            world.getBackground().fillRect(0,0,
            (world.getWidth()-world.getHeight())/2,
            world.getHeight());
            world.getBackground().fillRect(world.getWidth()-((world.getWidth()-world.getHeight())/2),0,
            ((world.getWidth()-world.getHeight())/2),
            world.getHeight());
        }
    }    
    
    char raycast(float p0_x, float p0_y, float p1_x, float p1_y, 
        float p2_x, float p2_y, float p3_x, float p3_y)
    {
        float s1_x, s1_y, s2_x, s2_y;
        s1_x = p1_x - p0_x;     s1_y = p1_y - p0_y;
        s2_x = p3_x - p2_x;     s2_y = p3_y - p2_y;
    
        float s, t;
        s = (-s1_y * (p0_x - p2_x) + s1_x * (p0_y - p2_y)) / (-s2_x * s1_y + s1_x * s2_y);
        t = ( s2_x * (p0_y - p2_y) - s2_y * (p0_x - p2_x)) / (-s2_x * s1_y + s1_x * s2_y);
    
        if (s >= 0 && s <= 1 && t >= 0 && t <= 1)
        {
            // Collision detected
            //if (i_x != NULL)
            //    *i_x = p0_x + (t * s1_x);
            //if (i_y != NULL)
            //    *i_y = p0_y + (t * s1_y);
            if(dist(p2_x, p2_y,(p0_x + (t * s1_x)),(p0_y + (t * s1_y)))
            > //if the new distance is great than the older value, don't overwrite it.
            dist(p2_x,p2_y,c.x,c.y))
            {
                return 0;
            } else {
                c = new Vector2(p0_x + (t * s1_x),p0_y + (t * s1_y));
            }
            return 1;
            //c = c;
            //return 0;
        }
    
        return 0; // No collision
    }
    
    public char PhysicsRay(Vector2 p0, Vector2 p1, Vector2 p2, Vector2 p3)
    {
        float s1_x, s1_y, s2_x, s2_y;
        s1_x = p1.x - p0.x;     s1_y = p1.y - p0.y;
        s2_x = p3.x - p2.x;     s2_y = p3.y - p2.y;
    
        float s, t;
        s = (-s1_y * (p0.x - p2.x) + s1_x * (p0.y - p2.y)) / (-s2_x * s1_y + s1_x * s2_y);
        t = ( s2_x * (p0.y - p2.y) - s2_y * (p0.x - p2.x)) / (-s2_x * s1_y + s1_x * s2_y);
    
        if (s >= 0 && s <= 1 && t >= 0 && t <= 1)
        {
            // Collision detected
            //if (i_x != NULL)
            //    *i_x = p0_x + (t * s1_x);
            //if (i_y != NULL)
            //    *i_y = p0_y + (t * s1_y);
            if(dist(p2.x, p2.y,(p0.x + (t * s1_x)),(p0.y + (t * s1_y)))
            > //if the new distance is great than the older value, don't overwrite it.
            dist(p2.x,p2.y,c.x,c.y))
            {
                return 0;
            } else {
                p = new Vector2(p0.x + (t * s1_x),p0.y + (t * s1_y));
            }
            return 1;
            //c = c;
            //return 0;
        }
    
        return 0; // No collision
    }
    
    public float dist(float x1, float y1, float x2, float y2)
    {
        return (float) Math.sqrt(Math.pow(x1-x2,2) + Math.pow(y1-y2,2));
    }
}